"""
/*
 * pybackup.py 0.2
 * pybackup.py for doing safer backups
 *
 * Copyright (C) Manuel Gutierrez Algaba,  2003 algaba@seul.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
*/
"""

import os
import dircache
import glob

def isacompressedfile(file):
    #print file, file[-6:] in ['tar.gz']
    if file[-3:] in ['zip', 'tgz', 'rpm', 'jpg'] or file[-6:] in ['tar.gz'] :
        return 1
    return None

def isatarorcompressedfile(file):
    return isacompressedfile(file) or file[-3:] in ['tar']
                                             
class conf:
    xtarext = ".xtar"
    def __init__(self):
        pass

class finddirs:
    def __init__(self):
        self.excludeddirs= []
        self.continuingdir =None #'.Trash/'

    def setExcludeddirs(self, a):
        self.excludeddirs += [a]
        return self
        
    def buildir(self, dir):
        return self.a[0] + dir + self.a[1]

    def getdirs(self,d):
        a= os.listdir(d)
        dircache.annotate(d, a)
        b = []
        for i in a:
            if  i.find('/') != -1:
                b+= [i]
        return b

    def getfiles(self, d):
        a= os.listdir(d)
        dircache.annotate(d, a)
        l = self.getdirs(d)
        b =[]
        for i in a:
            if i not in l:
                b += [i]
        return b    
    
    def test(self, d):
        print self.buildir("/home/thor")

    class RmExcep:
        def __init__(self, file):
            self.file = "Error removing file " + file
        def __str__(self):
            return self.file

    def doRm(self, f):
        if os.system('rm "' + f + '"') != 0:
            raise  self.RmExcep(f )

    def storeDirStruct(self, subdir, f):        
        if os.system('find "%s"/. -type d > "%s"  ' % (subdir , f  )) != 0:
            raise "Error stroDirStructing " + subdir + " " + f        

    def expandDirStruct(self, subdir, f ):
        if os.system("""
        for i in $(cat "%s"); do
        if test ! -d "%s"/$i; then
           mkdir "%s"/$i
        fi
        done
        """ % (f, subdir,subdir)) != 0:
            raise "Error expandDirStruct " + subdir + " " + f
    
    def doUnzipWD(self, direct, fz):
        """
        unzip + change of directory
        """
        print "Doing unzip: " + 'unzip  "' + fz  + '" '
        if os.system('cd "%s"; unzip  "' % direct + fz  + '"; rm "%s" ' % fz ) != 0:
            raise "Error uncompressing file " + fz

    class creaZipExcep:
        def __init__(self, file, fi):
            self.file = "Error creating zip file " + file
            self.file2 = fi
        def __str__(self):
            return self.file

    def doZip(self, fz, fi, option=" "):
        #print "Doing zip", fz, ",", fi, option
        if isatarorcompressedfile(fi):
            option +=  ' -0'
        zipcommand = 'zip %s  ' % option + ' "' + fz  + '" "' + fi +'"'
        
        if os.system(zipcommand ) != 0:
            raise self.creaZipExcep( fz, fi )

    class creaTarExcep:
        def __init__(self, file, fi):
            self.file = "Error creating tar file " + file + " adding " + fi
            self.file2 = fi
        def __str__(self):
            return self.file
        
    def doTar(self, ft, fi):
        if os.system('tar   uf "'+ ft + '" "' + fi + '" -b 1 --force-local') != 0:
            raise self.creaTarExcep( ft, fi)
            

    class MvExcep:
        def __init__(self, file):
            self.file = "Error moving file " + file
        def __str__(self):
            return self.file

    def doMv(self, fi, fo):
        if os.system("mv \""+ fi + "\" \"" + fo + "\"" ) != 0:
            raise self.MvExcep( fi)

    def makeAlternateDir(self, a):
        assert a[-1]=='/' 
        self.alternateDir = a
        return self

    def excluderepetitiveuntardirs(self, listoffilesindir, listofsubdirsindir):
        l = []
        for i in listoffilesindir:
            for j in listofsubdirsindir:
                if i.find(j[:-1]) != -1 and i!=j and isatarorcompressedfile(i) :
                    l.append(j)
        return l

    def compressdir(self, d):
        try:
            assert d[-1] == '/'
        except:
            print "Dir to compress (%s) must end in /\n\n\n" % d
            raise
        try:
            if self.continuingdir is None:
                self.doRm( d + conf.xtarext)
        except:
            pass

        if os.system('cd "%s"; touch arandomnamefilextar; rm arandomnamefilextar' % d) != 0:
            self.compressUnwritableDir(d)
            return "NOT WRITABLE DIR"               
        #os.system("tar cf " + d+conf.xtarext)
        l = self.getfiles(d)
        m = self.getdirs(d)
        excludeddirs = self. excluderepetitiveuntardirs(l, m)
        assert type(m) == type([]) and type([]) == type(excludeddirs)
        if self.continuingdir is None:
         for i in l:
            try:
                self.doZip(d+i + ".zip", d+i)
                self.doTar(d + conf.xtarext , d+i+".zip")
                self.doRm( d+i+".zip")
            except self.creaZipExcep, e:
                pass
        
        for i in m:
            if not self.continuingdir is None:
                print i
                if i== self.continuingdir:
                    self.continuingdir = None
                else:
                    continue
            if i in excludeddirs: continue # excluderepetitiveuntardirs
            if  os.path.islink( (d + i)[:-1]):
                # the link is packed as if it were a normal file
                
                try:
                    self.doZip(d+i[:-1] + ".zip", d+i[:-1], "-y")
                    self.doTar(d + conf.xtarext , d+i[:-1]+".zip")
                    self.doRm( d+i[:-1]+".zip")
                except self.creaTarExcep, e:
                    print e.file, e.file2
                    raise
                except  self.RmExcep, e :
                    raise
                
                continue
            if i[:-1] in self.excludeddirs: continue
            print "comprimiendo", i
            try:
                if self.compressdir(d+i)!='NOT WRITABLE DIR':
                    self.doMv(d+i+conf.xtarext,  d + i[:-1] + conf.xtarext )
                    self.doTar( d + conf.xtarext, d+i[:-1] + conf.xtarext)
                else:
                    self.doMv(self.genAltTar( d + i)+conf.xtarext,  d + i[:-1] + conf.xtarext )
                    self.doTar( d + conf.xtarext,  d + i[:-1] + conf.xtarext )

                self.doRm(d+i[:-1]+ conf.xtarext)

            except self.MvExcep, self.RmExcep:
                pass
            except:
                raise
        '''
        try:
            f = open(d + conf.xtarext, "r")
            f.close()
        except:
            raise "Assertion error " + d + conf.xtarext + " doesn\'t exist"
        '''        

    def genAltTar(self, a):
        return self.alternateDir + a.replace("/", "_" ) 

    def compressUnwritableDir(self, d):
        alt = self.alternateDir
        l = self.getfiles(d)
        m = self.getdirs(d)
        e = self. excluderepetitiveuntardirs(l, m)
        for i in l:
            try:
                self.doZip(alt + i + ".zip", d+i)
                self.doTar(self.genAltTar( d ) + conf.xtarext , alt+i+".zip")
                self.doRm( alt+i+".zip")
            except:
                pass
        
        for i in m:
            if i in e: continue # excluderepetitiveuntardirs
            if  os.path.islink( (d + i)[:-1]):
                # the link is packed as if it were a normal file
                
                try:
                    self.doZip(alt+i[:-1] + ".zip", d+i[:-1], "-y")
                    self.doTar(self.genAltTar(d) + conf.xtarext ,
                               alt+i[:-1]+".zip")
                    self.doRm( alt+i[:-1]+".zip")
                except self.creaTarExcep, e:
                    print e.file, e.file2
                    raise
                except  self.RmExcep, e :
                    raise
                
                continue
            if i[:-1] in self.excludeddirs: continue
            print "comprimiendo", i
            try:
                if self.compressdir(d+i)!='NOT WRITABLE DIR':
                    # is this branch right ?
                    self.doMv(d+i+conf.xtarext,  self.genAltTar(d + i[:-1]) + conf.xtarext)
                    self.doTar(self.genAltTar(d + conf.xtarext), self.genAltTar(d+i[:-1]) + conf.xtarext)
                    self.doRm(self.genAltTar(d+i[:-1]) + conf.xtarext)
                else:
                    # Then both "father" and "son" dir are in the same
                    # directory for storing the tar files, so no move is 
                    # necessary
                    self.doTar( self.genAltTar( d ) + conf.xtarext,
                                self.genAltTar( d+i ) + conf.xtarext)
                    self.doRm(self.genAltTar( d+i) + conf.xtarext)

            except self.MvExcep, self.RmExcep:
                pass
            except:
                raise

    def makelistdir(self):
        pass

    def untar(self, dir, tarfile, file):
        os.system(' tar   xf "%s" "%s" -C "%s"' % ( tarfile, file, dir ))
        
    def extractdirs(self, tarfile, subdir):
        self.untar(subdir, tarfile, " ")
        #for i in glob.glob("subdir", 
        #self.decompress()

    def genxtarpy(self, tarfile, subdir):
        a= '''
        touch "%s"/xtar.py; (echo -ne listfile=[;  for i in $(tar tf "%s" 2>/dev/null); do echo -ne \\"$i\\", ; done; echo None ]) > "%s"/xtar.py
        ''' % (subdir, tarfile, subdir)
        os.system(a)
        #print a

    def launch(self, tarfile, subdir, level=0 ):
        assert not "/"  in subdir
        self.genxtarpy(tarfile,subdir)
        exec(self. readstring( subdir + "/" + "xtar.py"))
        print listfile
        listfile = listfile[:-1]
        self.doMv(tarfile, tarfile + "itar")
        for i in listfile:
            a='''
            tar   -x -O -f "%s" "%s"  >"%s"/"%s"
            ''' %  ( tarfile + "itar", i, subdir,  i[i.rfind("/")+1:] ) 
            print "Extracting", a
            os.system(a)
            #print "glob", glob.glob(subdir +"/*")
            analize=glob.glob(subdir + "/*xtar")
            print "Next candidates ", analize, "level ", level
            for i in analize:
                self.launch(i, subdir, level + 1)
        self.doMv( tarfile + "itar", tarfile)
        if level!= 0:
            self.doRm(tarfile)

    def printcontent(self,  tarfile, subdir, level=0):
        assert not "/"  in subdir
        self.genxtarpy(tarfile,subdir)
        exec(self. readstring( subdir + "/" + "xtar.py"))
        listfile = listfile[:-1]
        self.doMv(tarfile, tarfile + "itar")
        a = '''
        tar tf "%s"  > "%s"/lxtar
        ''' % (tarfile + "itar", subdir)
        os.system(a)
        o = open('"%s"/lxtar' % subdir, "r")
        l = o.readlines()
        for i in l:
            print i[:-1]
        o.close()
        
        for i in listfile:
            if i.find("xtar")=='-1':
                continue
            a='''
            tar   -x -O -f "%s" "%s"  >"%s"/"%s"
            ''' %  ( tarfile + "itar", i, subdir,  i[i.rfind("/")+1:] ) 
            os.system(a)
            analize=glob.glob(subdir + "/*xtar")
            for i in analize:
                self.printcontent(i, subdir, level + 1)
        self.doMv( tarfile + "itar", tarfile)
        if level!= 0:
            self.doRm(tarfile)
            
    def expandzipfiles(self, subdir):
        l = self.getfiles(subdir)
        for i in l:
            if i.rfind(".zip") == len(i) - len(".zip"):
                self.doUnzipWD(subdir, i)

    def readstring(self, file):
        f= open(file, "r")
        a= f.readline()
        f.close()
        return a

def backuphomedir():
    f= finddirs().makeAlternateDir("/tmp/"). setExcludeddirs("tmpant")
    f. continuingdir = '.Trash'
    f= compressdir("/home/thor/")

#backuphomedir()

def backupe():
    '''
    os.system("rm -Rf /home/thor/hroyectos/pybackup/e/*")
finddirs().compressdir("test/")
finddirs(). printcontent("test/.xtar", "e" )
finddirs().launch("test/.xtar", "e" )

finddirs().expandzipfiles("e")
finddirs(). storeDirStruct("test", "estructdir" )
'''
    finddirs().makeAlternateDir("/tmp/"). setExcludeddirs("tmpant"). setExcludeddirs('turist').  compressdir("test/")
    finddirs().launch("test/.xtar", "e" )
    finddirs().expandzipfiles("e")

    
#.expandDirStruct("e", "estructdir")
'''
    print finddirs().getdirs("/home/thor")
    finddirs().visit("/home/thor/")
    print finddirs().getfiles("/home/thor")
'''
